!part 1.A and B
	implicit none
!==================
	integer,parameter:: N=16,N2=2*N
	complex,dimension(0:N-1):: U,DUDX,UHALF
	real,   dimension(0:N-1):: X
	
	complex,dimension(0:N-1):: UDFT,CTMP
	real:: TPI,DX
	integer:: I,K


	TPI = 2*acos(-1.0)
	DX = TPI/N

	DO I=0,N-1
	 X(I)= I*DX
         U(I)   =   cos(3*X(I))
	 DUDX(I)= -3*sin(3*X(I))
	 UHALF(I)= cos(3* (X(I)+DX/2.0) )
	ENDDO

!find DFT of U
	UDFT=U
	call FFT(UDFT,N,0)
!-----------------------------
! compute derivative using DFT	
	DO K=0,N/2
	 CTMP(K) = UDFT(K) *cmplx(0.0,K )
	ENDDO
	DO K=N/2+1,N-1
	 CTMP(K) = UDFT(K)*cmplx(0.0,N-K)*(-1) !NOTE (-1)
	ENDDO

	call FFT(CTMP,N,1)
!-----------------------------
	write(*,*) " 1 A"
	write(*,*) "X,DUDX,APPROX,ERROR"
	DO I=0,N-1
	 write(*,*) X(I),real(DUDX(I)),real(CTMP(I)),real(DUDX(I)-CTMP(I))
	enddo
	write(*,*)"------------------------------"
!PART B
!-----------------------------
! compute  1/2 step using DFT	
	DO K=0,N/2
	 CTMP(K) = UDFT(K) *exp(  K*cmplx(0.0,DX/2.) )
	ENDDO
	DO K=N/2+1,N-1
	 CTMP(K) = UDFT(K)*exp((N-K)*cmplx(0.0,DX/2.)*(-1) ) !NOTE (-1)
	ENDDO

	call FFT(CTMP,N,1)
!-----------------------------
	
	write(*,*) " 1 B"
	write(*,*) "X,UHALF,APPROX,ERROR"
	DO I=0,N-1
	 write(*,*) X(I)+DX/2.0,real(UHALF(I)),real(CTMP(I)),real(UHALF(I)-CTMP(I))
	enddo
	write(*,*)"------------------------------"


	END
