	implicit none
	integer, parameter ::N=16,N2=2*N
	complex,dimension(0:N-1):: U,UDFT,V,VDFT,W,UHAT,VHAT,WHAT
	real,dimension(0:N)::X

	complex,dimension(0:N-1)::C1,C2,WNEW
	real::TPI,DX
	integer::I,K

	TPI = 2*acos(-1.0)
	DX = TPI/N

	DO I=0,N-1
	 X(I)= I*DX
	 U(I)= cos(7*X(I))
	 V(I)= cos(7*X(I))
	ENDDO
! Take DFT
	UDFT=U
	VDFT=V
	call fft (UDFT,N,0)
	call fft (VDFT,N,0)

! aliasing experiment
! PHASE FACTOR
	DO K=0,N/2
	 C1(K) = exp( K*cmplx(0.0,DX/2.0))
	ENDDO
	DO K=N/2+1,N-1
	 C1(K) = exp((N-K)*cmplx(0.0,DX/2.0)*(-1))
	ENDDO
	C2= conjg(C1)
!=======================================
! UHAT,VHAT HALF STEP version of U, V
	UHAT= UDFT*C1
	VHAT= VDFT*C1
	call fft(UHAT,N,1)
	call fft(VHAT,N,1)
!============================
	DO I=0,N-1
	 W(I)   = U(I)*   V(I)
	 WHAT(I)= UHAT(I)*VHAT(I)
	ENDDO
!===========================
	call fft(W,N,0)
	call fft(WHAT,N,0)
	
	do K=0,N-1
	 WNEW(K) = 0.5*(W(K) +C2(K)*WHAT(K))
	enddo

	call fft(WNEW,N,1)

	write(*,*) ' X, UV,WNEW, ALIAS ERROR'
	do I=0,N-1
	 write(*,*) X(I), real(U(I)*V(I)),real(WNEW(I)), real(U(I)*V(I)-WNEW(I))
	enddo


	END
